## kalign 1.04

=== Makefile ===
PREFIX		= /usr/local/bin
CC				= gcc  
CFLAGS		= -O9 -funroll-loops -fomit-frame-pointer -pipe  -Wall 
DEBUGFLAGS	= -ggdb -Wall -m32

SOURCES		= kalign.c
PROGS			= kalign
OBJECTS		= $(SOURCES:.c=.o)
DEBUGPROGS	= kalign_debug
DEBUGOBJECTS	= $(SOURCES:.c=_debug.o)

kalign: $(OBJECTS)
	$(CC) $(CFLAGS) $(OBJECTS) -o $(PROGS)
kalign.o: kalign.c
	$(CC) $(CFLAGS) -c kalign.c

debug: $(DEBUGOBJECTS)
	$(CC) $(DEBUGFLAGS) $(DEBUGOBJECTS) -o $(DEBUGPROGS)	

%_debug.o:	%.c
	$(CC) $(DEBUGFLAGS) -c $< -o $@

install : 
	mkdir -p $(PREFIX)
	cp $(PROGS)  $(PREFIX)
	chmod 755 $(PREFIX)/$(PROGS)

clean: 
	rm -f $(PROGS) $(OBJECTS)
	rm -f *~

## kalign 2.03%2B20110620

=== debian/changelog ===
kalign (1:2.03+20110620-3) unstable; urgency=low

  * Team upload

  [ Andreas Tille ]
  * debian/upstream: Added some information from debian/reference
  * debian/reference: Removed in favour of debian/upstream
  * Moved packaging from SVN to Git
  * cme fix dpkg-control
  * add hardening options

  [ Canberk Koç ]
  * Autopkgtest added

 -- Canberk Koç <canberkkoc@gmail.com>  Thu, 28 Jul 2016 03:06:04 +0300

kalign (1:2.03+20110620-2) unstable; urgency=low

  [ Charles Plessy ]
  * renamed debian/upstream-metadata.yaml to debian/upstream

  [ Andreas Tille ]
  * debian/upstream:
     - Added another citation from tasks file
     - Fixed Homepage
  * debian/source/format: 3.0 (quilt)
  * debian/watch: Fixed hint to download URL
  * debian/control:
     - Fixed Homepage
     - Standards-Version: 3.9.3 (no changes needed)
  * debian/copyright: Fixed DEP5 issues and verified using
      cme fix dpkg-copyright
  * debhelper 9 (control+compat)

 -- Andreas Tille <tille@debian.org>  Thu, 29 Mar 2012 15:28:43 +0200

kalign (1:2.03+20110620-1) unstable; urgency=low

  * New upstream release.
    Using 2.04 as a version number was a mistake of mine, it should have been
    called 2.03+20081031 as Upstream sometimes updates the source archive
    ‘current.tar.gz’ without incrementing the version number.
  * Collected information about Upstream in ‘debian/upstream-metadata.yaml’.
  * Using Debhelper 8 (debian/compat, debian/control).
  * Corrected VCS information in debian/control.
  * Enhances: bioperl-run, that has a kalign wrapper (debian/control).
  * Incremented Standards-Version to reflect conformance with Policy 3.9.2.
    (debian/control, no changes needed).

 -- Charles Plessy <plessy@debian.org>  Sat, 25 Jun 2011 17:23:01 +0900

kalign (2.04-2) unstable; urgency=low

  [ David Paleino ]
  * Removed myself from Uploaders

  [ Andreas Tille ]
  * debian/control:
    - Standards-Version: 3.8.3
    - debhelper (>= 7.1) to use override facility
  * debian/rules:
    - removed code to create manpage - just keep the created one
    - short rules file using dh
  * debian/watch:
    - deactivated; upstream does not seem to respond to our request
      to enable versioned tarballs - so the watch file makes no sense
      Closes: #456479
  * Applied patch to enable bash completion.  Thanks to David Paleino
    <d.paleino@gmail.com>
    Closes: #446047

 -- Andreas Tille <tille@debian.org>  Tue, 06 Oct 2009 16:21:45 +0200

kalign (2.04-1) unstable; urgency=low

  * New upstream release.
  * debian/copyright made machine-readable.
  * debian/rules: replaced deprecated dh_clean -k by dh_prep.
  * debian/control:
    - Updated my email address (debian/control).
    - Checked compliance with Policy 3.8.0 (no changes needed).
    - Using debhelper 7 (also in debian/compat).
    - Upadated description and moved reference to debian/reference.
  * debian/kalign.1*: updated the manual pages.

 -- Charles Plessy <plessy@debian.org>  Thu, 26 Feb 2009 00:19:44 +0900

kalign (2.03-2) unstable; urgency=low

  [ Charles Plessy ]
  * debian/control:
    - Add Subversion repository URL to debian/control.
    - Moved the Homepage: field out from the package's description.
    - Enhances: t-coffee.

  [ David Paleino ]
  * debian/kalign.1 added - manpages are now statically generated
  * debian/control:
    - B-D updated (see above)
    - added myself to Uploaders
    - moved XS-Vcs-* fields to Vcs-*
  * debian/rules:
    - reflecting static build of manpages
    - minor changes
  * Updated to Standards-Version 3.7.3 (no changes needed)

  [ Andreas Tille ]
  * Added myself to Uploaders

 -- Andreas Tille <tille@debian.org>  Tue, 18 Mar 2008 09:54:17 +0100

kalign (2.03-1) unstable; urgency=low

  * New upstream release.
  * Mended the watch file.
  * Updated the manpage.

 -- Charles Plessy <charles-debian-nospam@plessy.org>  Wed, 21 Feb 2007 09:07:33 +0900

kalign (1.04-1) unstable; urgency=low

  * Initial release Closes: #365344

 -- Charles Plessy <charles-debian-nospam@plessy.org>  Sat, 29 Apr 2006 23:02:57 +0900

## kalign 2.03+20110620

=== debian/control ===
Source: kalign
Section: science
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
DM-Upload-Allowed: yes
Uploaders: Charles Plessy <plessy@debian.org>,
 Andreas Tille <tille@debian.org>
Build-Depends: debhelper (>= 9)
Standards-Version: 3.9.3
Vcs-Browser: http://svn.debian.org/wsvn/debian-med/trunk/packages/kalign/trunk/
Vcs-Svn: svn://svn.debian.org/debian-med/trunk/packages/kalign/trunk/
Homepage: http://msa.sbc.su.se/

Package: kalign
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Enhances: t-coffee, bioperl-run
Description: Global and progressive multiple sequence alignment
 Kalign is a command line tool to perform multiple alignment of
 biological sequences. It employs the Muth-Manber string-matching
 algorithm, to improve both the accuracy and speed of the alignment.
 It uses global, progressive alignment approach, enriched by employing
 an approximate string-matching algorithm to calculate sequence
 distances and by incorporating local matches into the otherwise global
 alignment.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Build rules for the Debian package kalign

pkg:=kalign

%:
	dh $@

override_dh_auto_install:
	install -D -m u=rw,go=r debian/$(pkg).bash_completion $(CURDIR)/debian/$(pkg)/etc/bash_completion.d/$(pkg)

=== debian/watch ===
# There is no more version number: http://msa.sbc.su.se/downloads/kalign/current.tar.gz
#version=3
#http://msa.cgb.ki.se/downloads/ kalign-?(\d).(\d+).tgz

## kalign 3.2.3

=== debian/changelog ===
kalign (1:3.2.3-4) unstable; urgency=medium

  * Team Upload.
  [ Michael R. Crusoe ]
  * patches forwarded upstream

  [ Nilesh Patra ]
  * Fix gcc-10 FTBFS (Closes: #966865)
  * Add manpages
  * compat version: 13, run wrap-and-sort

 -- Nilesh Patra <npatra974@gmail.com>  Tue, 04 Aug 2020 21:43:28 +0000

kalign (1:3.2.3-3) unstable; urgency=medium

  * Team upload.
  * Use the libsimde-dev package instead of our code copy

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Mon, 20 Apr 2020 19:13:36 +0200

kalign (1:3.2.3-2) unstable; urgency=medium

  * Team upload.
  * Add non-AVX2 compatability using the SIMD Everywhere library
  * Compile using all levels of SIMD CPU support and restructure package
    with a "simd-dispatch" script
  * debian/patches/hardening: keep the provided CFLAGS

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Mon, 30 Mar 2020 20:25:57 +0200

kalign (1:3.2.3-1) unstable; urgency=medium

  * Team upload.

  [ Charles Plessy ]
  * New upstream version (packaging in progress).

  [ Andreas Tille ]
  * Standards-Version: 4.5.0 (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Use secure URI in Homepage field.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Remove obsolete fields Contact, Name from debian/upstream/metadata
    (already present in machine-readable debian/copyright).

  [ Pranav Ballaney ]
  * Fix autopkgtest and add more test

 -- Pranav Ballaney <ballaneypranav@gmail.com>  Sat, 21 Mar 2020 01:35:29 +0530

kalign (1:2.03+20110620-5) unstable; urgency=medium

  [ Jelmer Vernooĳ ]
  * Use secure copyright file specification URI.

  [ Andreas Tille ]
  * Fake watch file
  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.3.0

 -- Andreas Tille <tille@debian.org>  Tue, 08 Jan 2019 13:51:16 +0100

kalign (1:2.03+20110620-4) unstable; urgency=medium

  * propagate CC from ./configure to make (Thanks for the patch to Helmut Grohne
    <helmut@subdivi.de>)
    Closes: #890256
  * Standards-Version: 4.1.3
  * debhelper 11

 -- Andreas Tille <tille@debian.org>  Mon, 12 Feb 2018 16:39:29 +0100

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Build rules for the Debian package kalign

include /usr/share/dpkg/default.mk
export DEB_CFLAGS_MAINT_APPEND += -DSIMDE_ENABLE_OPENMP -fopenmp-simd -O3
export DEB_CXXFLAGS_MAINT_APPEND += -DSIMDE_ENABLE_OPENMP -fopenmp-simd -O3
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
prefix=$(CURDIR)/debian/$(DEB_SOURCE)/usr
libexecdir=$(prefix)/lib/$(DEB_SOURCE)

%:
	dh $@

override_dh_auto_build:
ifeq (amd64,$(DEB_HOST_ARCH))
	mkdir -p $(prefix)
	mkdir -p $(libexecdir)
	# pulled avx2 out of the loop to pass the HAVE_AVX2 flag that the source looks for
	dh_auto_configure -- CFLAGS="-DHAVE_AVX2=1 $(CFLAGS) -mavx2" &&\
		dh_auto_build
	cp src/kalign src/kalign-avx2
	cp src/timescorealn src/timescorealn-avx2
	for SIMD in avx sse4.1 ssse3 sse3 sse2 ; do \
		make clean ; \
		dh_auto_configure -- CFLAGS="$(CFLAGS) -m$${SIMD}" && \
		dh_auto_build && \
		cp src/kalign src/kalign-$${SIMD} && \
		cp src/timescorealn src/timescorealn-$${SIMD} ; \
	done
else ifeq (i386,$(DEB_HOST_ARCH))
	mkdir -p $(prefix)
	mkdir -p $(libexecdir)
	for SIMD in ssse3 sse3 sse2 sse mmx; do \
		dh_auto_configure -- CFLAGS="$(CFLAGS) -m$${SIMD}" && \
		dh_auto_build && \
		cp src/kalign src/kalign-$${SIMD} && \
		cp src/timescorealn src/timescorealn-$${SIMD} && \
		make clean ; \
	done
	dh_auto_build
	cp src/kalign src/kalign-plain && \
	cp src/timescorealn src/timescorealn-plain
else
	dh_auto_build
endif

override_dh_auto_install:
ifeq (amd64,$(DEB_HOST_ARCH))
	dh_install debian/bin/simd-dispatch /usr/lib/$(DEB_SOURCE)/
	dh_install src/kalign-* usr/lib/$(DEB_SOURCE)/
	dh_install src/timescorealn-* usr/lib/$(DEB_SOURCE)/
	mkdir -p $(prefix)/bin
	cd $(prefix)/bin \
	        && for prog in kalign timescorealn ; do \
	        ln -s ../lib/$(DEB_SOURCE)/simd-dispatch $${prog} ; done
else ifeq (i386,$(DEB_HOST_ARCH))
	dh_install debian/bin/simd-dispatch /usr/lib/$(DEB_SOURCE)/
	dh_install src/kalign-* usr/lib/$(DEB_SOURCE)/
	dh_install src/timescorealn-* usr/lib/$(DEB_SOURCE)/
	mkdir -p $(prefix)/bin
	cd $(prefix)/bin \
	        && for prog in kalign timescorealn ; do \
	        ln -s ../lib/$(DEB_SOURCE)/simd-dispatch $${prog} ; done
else
	dh_auto_install
endif

override_dh_gencontrol:
	dh_gencontrol -- -Vsimde:Built-Using="$(shell dpkg-query -f '$${source:Package} (= $${source:Version}), ' -W "libsimde-dev")"

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz@PACKAGE@-$1.tar.gz%" \
  https://github.com/TimoLassmann/kalign/tags \
  (?:.*?/)?v?(\d[\d.]*)\.tar\.gz

## kalign 3.3

=== debian/changelog ===
kalign (1:3.3-1) unstable; urgency=medium

  * Team upload.
  * debian/watch: fix syntax
  * refresh patches; drop "hardening", it was applied upstream.
  * Added a patch to retain debugging symbols

 -- Michael R. Crusoe <crusoe@debian.org>  Fri, 06 Nov 2020 10:40:38 +0100

=== debian/control ===
Source: kalign
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Charles Plessy <plessy@debian.org>, Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13), libsimde-dev
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/med-team/kalign
Vcs-Git: https://salsa.debian.org/med-team/kalign.git
Homepage: https://msa.sbc.su.se/
Rules-Requires-Root: no

Package: kalign
Architecture: any
Built-Using: ${simde:Built-Using}
Depends: ${misc:Depends}, ${shlibs:Depends}
Enhances: bioperl-run, t-coffee
Description: Global and progressive multiple sequence alignment
 Kalign is a command line tool to perform multiple alignment of
 biological sequences. It employs the Muth-Manber string-matching
 algorithm, to improve both the accuracy and speed of the alignment.
 It uses global, progressive alignment approach, enriched by employing
 an approximate string-matching algorithm to calculate sequence
 distances and by incorporating local matches into the otherwise global
 alignment.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Build rules for the Debian package kalign

include /usr/share/dpkg/default.mk
export DEB_CFLAGS_MAINT_APPEND += -DSIMDE_ENABLE_OPENMP -fopenmp-simd -O3
export DEB_CXXFLAGS_MAINT_APPEND += -DSIMDE_ENABLE_OPENMP -fopenmp-simd -O3
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
prefix=$(CURDIR)/debian/$(DEB_SOURCE)/usr
libexecdir=$(prefix)/lib/$(DEB_SOURCE)

%:
	dh $@

AMD64_SIMD_LEVELS=avx2 avx sse4.1 ssse3 sse3
i386_SIMD_LEVELS=sse2 sse

override_dh_auto_build:
ifneq (,$(filter $(DEB_HOST_ARCH),amd64 i386))
	mkdir -p $(prefix)
	mkdir -p $(libexecdir)
	$(foreach SIMD,$(AMD64_SIMD_LEVELS), make clean ; dh_auto_configure -- CFLAGS="$(CFLAGS) -m$(SIMD)" && dh_auto_build && cp src/kalign src/kalign-$(SIMD) && cp src/timescorealn src/timescorealn-$(SIMD) && ) true
	make clean ; dh_auto_configure && dh_auto_build && \
		cp src/kalign src/kalign-plain && \
		cp src/timescorealn src/timescorealn-plain
ifeq (i386,$(DEB_HOST_ARCH))
	$(foreach SIMD,$(i386_SIMD_LEVELS), make clean ; dh_auto_configure -- CFLAGS="$(CFLAGS) -m$(SIMD)" && dh_auto_build && cp src/kalign src/kalign-$(SIMD) && cp src/timescorealn src/timescorealn-$(SIMD) && ) true
endif
else
	dh_auto_build
endif

override_dh_auto_install:
ifneq (,$(filter $(DEB_HOST_ARCH),amd64 i386))
	dh_install debian/bin/simd-dispatch /usr/lib/$(DEB_SOURCE)/
	dh_install src/kalign-* usr/lib/$(DEB_SOURCE)/
	dh_install src/timescorealn-* usr/lib/$(DEB_SOURCE)/
	mkdir -p $(prefix)/bin
	cd $(prefix)/bin \
	        && $(foreach PROG,kalign timescorealn,ln -s ../lib/$(DEB_SOURCE)/simd-dispatch $(PROG) &&) true
else
	dh_auto_install
endif

override_dh_gencontrol:
	dh_gencontrol -- -Vsimde:Built-Using="$(shell dpkg-query -f '$${source:Package} (= $${source:Version}), ' -W "libsimde-dev")"

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
  https://github.com/TimoLassmann/kalign/releases .*/archive/v@ANY_VERSION@\.tar\.gz

## kalign 3.3.1

=== debian/changelog ===
kalign (1:3.3.1-1) unstable; urgency=medium

  * Fix watchfile to detect new versions on github
  * New upstream version
  * Standards-Version: 4.6.0 (routine-update)

 -- Andreas Tille <tille@debian.org>  Fri, 01 Oct 2021 13:15:46 +0200

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Section: science
 Priority: optional
 Build-Depends: debhelper-compat (= 13), libsimde-dev
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/med-team/kalign
 Vcs-Git: https://salsa.debian.org/med-team/kalign.git
 Homepage: https://msa.sbc.su.se/

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
  https://github.com/TimoLassmann/kalign/releases .*/v@ANY_VERSION@\.tar\.gz

## kalign 3.3.2

=== debian/changelog ===
kalign (1:3.3.2-1) unstable; urgency=medium

  * New upstream version
  * Refresh SIMDE patch

 -- Andreas Tille <tille@debian.org>  Mon, 02 May 2022 14:39:41 +0200

## kalign 3.3.5

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)

project(kalign LANGUAGES C CXX)

set(NAMESPACE_NAME "kalign")
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

option(BUILD_SHARED_LIBS "Build the shared library" ON)

include(GNUInstallDirs)
include(CMakePackageConfigHelpers)
include(GenerateExportHeader)

set(KALIGN_LIBRARY_VERSION_MAJOR 3)
set(KALIGN_LIBRARY_VERSION_MINOR 3)
set(KALIGN_LIBRARY_VERSION_PATCH 5)
set(KALIGN_LIBRARY_VERSION_STRING ${KALIGN_LIBRARY_VERSION_MAJOR}.${KALIGN_LIBRARY_VERSION_MINOR}.${KALIGN_LIBRARY_VERSION_PATCH})


set (CMAKE_C_STANDARD 11)

# SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -pg")
# SET(CMAKE_CXX_FLAGS "${CMAKE_C_FLAGS} -pg")
# SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -pg")
# SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -pg")

# to compile without open mp:
# cmake -DCMAKE_EXPORT_COMPILE_COMMANDS=ON -DUSE_OPENMP=OFF ..

add_compile_options("$<$<CONFIG:RELEASE>:-W;-Wall;-O3;-pedantic>")
add_compile_options("$<$<CONFIG:DEBUG>:-W;-Wall;-O0;-g;-pedantic>")

if(CMAKE_PROJECT_NAME STREQUAL PROJECT_NAME)
  if (MSVC)
    # warning level 4 and all warnings as errors
    add_compile_options(/W4 /WX)
  else()
    # lots of warnings and all warnings as errors
    add_compile_options(-Wall -Wextra -pedantic )
  endif()
endif()

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release)
endif()

include(GNUInstallDirs)

include(CTest)
include(CheckCSourceRuns)

option(USE_OPENMP    "Use OpenMP for parallelization" ON)
option(ENABLE_SSE    "Enable compile-time SSE4.1 support." ON)
option(ENABLE_AVX    "Enable compile-time AVX support."    ON)
option(ENABLE_AVX2   "Enable compile-time AVX2 support."   ON)
# option(ENABLE_FMA    "Enable compile-time FMA support."    ON)
# option(ENABLE_AVX512 "Enable compile-time AVX512 support." ON)


if(USE_OPENMP)
  find_package(OpenMP)
  if(OPENMP_FOUND OR OpenMP_FOUND)
    message(STATUS "OpenMP is enabled.")
     
     add_definitions (-DHAVE_OPENMP)
  else(OPENMP_FOUND OR OpenMP_FOUND)
    message(STATUS "OpenMP not supported")
  endif(OPENMP_FOUND OR OpenMP_FOUND)
endif(USE_OPENMP)


if (ENABLE_SSE)
  #
  # Check compiler for SSE4_1 intrinsics
  #
  if (CMAKE_COMPILER_IS_GNUCC OR (CMAKE_C_COMPILER_ID MATCHES "Clang") OR (CMAKE_CXX_COMPILER_ID MATCHES "Clang"))
    set(CMAKE_REQUIRED_FLAGS "-msse4.1")
    check_c_source_runs("
        #include <emmintrin.h>
        #include <smmintrin.h>
        int main()
        {
        __m128i a = _mm_setzero_si128();
        __m128i b = _mm_minpos_epu16(a);
        return 0;
        }"
      HAVE_SSE)
  endif()

  if (HAVE_SSE)        
    message(STATUS "SSE4.1 is enabled - target CPU must support it")
  endif()
  
  if (ENABLE_AVX)

    #
    # Check compiler for AVX intrinsics
    #
    if (CMAKE_COMPILER_IS_GNUCC OR (CMAKE_C_COMPILER_ID MATCHES "Clang") OR (CMAKE_CXX_COMPILER_ID MATCHES "Clang"))
      set(CMAKE_REQUIRED_FLAGS "-mavx")
      check_c_source_runs("
            #include <immintrin.h>
            int main()
            {
              __m256 a, b, c;
              const float src[8] = { 1.0f, 2.0f, 3.0f, 4.0f, 5.0f, 6.0f, 7.0f, 8.0f };
              float dst[8];
              a = _mm256_loadu_ps( src );
              b = _mm256_loadu_ps( src );
              c = _mm256_add_ps( a, b );
              _mm256_storeu_ps( dst, c );
              int i = 0;
              for( i = 0; i < 8; i++ ){
                if( ( src[i] + src[i] ) != dst[i] ){
                  return -1;
                }
              }
              return 0;
            }"
        HAVE_AVX)
    endif()

    if (HAVE_AVX)
      message(STATUS "AVX is enabled - target CPU must support it")
    endif()
  endif()
  
  if (ENABLE_AVX2)

    #
    # Check compiler for AVX intrinsics
    #
    if (CMAKE_COMPILER_IS_GNUCC OR (CMAKE_C_COMPILER_ID MATCHES "Clang") OR (CMAKE_CXX_COMPILER_ID MATCHES "Clang"))
      set(CMAKE_REQUIRED_FLAGS "-mavx2")
      check_c_source_runs("
          #include <immintrin.h>
          int main()
          {
            __m256i a, b, c;
            const int src[8] = { 1, 2, 3, 4, 5, 6, 7, 8 };
            int dst[8];
            a =  _mm256_loadu_si256( (__m256i*)src );
            b =  _mm256_loadu_si256( (__m256i*)src );
            c = _mm256_add_epi32( a, b );
            _mm256_storeu_si256( (__m256i*)dst, c );
            int i = 0;
            for( i = 0; i < 8; i++ ){
              if( ( src[i] + src[i] ) != dst[i] ){
                return -1;
              }
            }
            return 0;
          }"
        HAVE_AVX2)
    endif()

    if (HAVE_AVX2)
      message(STATUS "AVX2 is enabled - target CPU must support it")
    endif()
  endif()
endif()

if (HAVE_AVX2)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mavx2 -DHAVE_AVX2")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -mavx2 -DHAVE_AVX2")
else(HAVE_AVX2)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DNOHAVE_AVX2")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DNOHAVE_AVX2")
endif(HAVE_AVX2)



add_subdirectory(lib)
add_subdirectory(src)
add_subdirectory(tests)


MESSAGE(STATUS "")
MESSAGE(STATUS "Configuration:")
MESSAGE(STATUS "--------------------------------------")
MESSAGE(STATUS "Build type                : " ${CMAKE_BUILD_TYPE})
MESSAGE(STATUS "Compiler flags            : " ${CMAKE_C_COMPILE_FLAGS})
MESSAGE(STATUS "Compiler c debug flags    : " ${CMAKE_C_FLAGS_DEBUG})
MESSAGE(STATUS "Compiler c release flags  : " ${CMAKE_C_FLAGS_RELEASE})
MESSAGE(STATUS "Compiler c min size flags : " ${CMAKE_C_FLAGS_MINSIZEREL})
MESSAGE(STATUS "Compiler c flags          : " ${CMAKE_C_FLAGS})
message(STATUS "OpenMP version            : " ${OpenMP_C_VERSION})
message(STATUS "OpenMP flags              : " ${OpenMP_C_FLAGS})

# Package Generator  #######################################################
set(CPACK_PACKAGE_VENDOR "Timo Lassmann")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Kalign")
set(CPACK_PACKAGE_VERSION_MAJOR ${KALIGN_LIBRARY_VERSION_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR ${KALIGN_LIBRARY_VERSION_MINOR})
set(CPACK_PACKAGE_VERSION_PATCH ${KALIGN_LIBRARY_VERSION_PATCH})
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/COPYING")
# set(CPACK_RESOURCE_FILE_README "${CMAKE_CURRENT_SOURCE_DIR}/README.org")
set(CPACK_SOURCE_GENERATOR "TGZ;ZIP")
set(CPACK_SOURCE_IGNORE_FILES
  /.cache
  /.git
  /GPATH
  /GTAGS
  /GRTAGS
  /.*build.*
  /.dir-locals.el
  /\\\\.DS_Store
  )
include (CPack)

=== lib/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)

if(NOT KALIGN_PACKAGE_NAME)
  set(KALIGN_PACKAGE_NAME ${CMAKE_PROJECT_NAME})
endif()

if(NOT KALIGN_PACKAGE_VERSION)
  set(KALIGN_PACKAGE_VERSION ${KALIGN_LIBRARY_VERSION_STRING})
endif()

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fPIC")


configure_file ("${CMAKE_CURRENT_SOURCE_DIR}/src/version.h.in" "version.h")


set(source_files
  src/test.c
  src/tldevel.c
  src/tlmisc.c
  src/tlrng.c
  src/esl_stopwatch.c
  src/msa_alloc.c
  src/msa_op.c
  src/msa_io.c
  src/msa_misc.c
  src/msa_check.c
  src/msa_cmp.c
  src/alphabet.c

  src/task.c

  src/bisectingKmeans.c
  src/sequence_distance.c
  src/bpm.c
  src/euclidean_dist.c
  src/pick_anchor.c
  
  src/aln_wrap.c

  src/aln_param.c
  src/aln_run.c
  src/aln_mem.c
  src/aln_setup.c
  src/aln_controller.c
  src/aln_seqseq.c
  src/aln_seqprofile.c
  src/aln_profileprofile.c
  src/weave_alignment.c
  # src/test.h
  )

add_library(${PROJECT_NAME}_OBJ OBJECT ${source_files})

if(OpenMP_C_FOUND)  
  target_link_libraries(${PROJECT_NAME}_OBJ PRIVATE OpenMP::OpenMP_C)
endif(OpenMP_C_FOUND)

target_include_directories(${PROJECT_NAME}_OBJ
  PRIVATE
  ${CMAKE_CURRENT_BINARY_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}/include
  )

add_library(${PROJECT_NAME})
add_library(${NAMESPACE_NAME}::${PROJECT_NAME} ALIAS ${PROJECT_NAME})



generate_export_header(${PROJECT_NAME}
  EXPORT_FILE_NAME ${PROJECT_NAME}/${PROJECT_NAME}_export.h
  )

set(public_header_files
  ${CMAKE_SOURCE_DIR}/lib/include/kalign/kalign.h
  ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}/${PROJECT_NAME}_export.h
  #${CMAKE_CURRENT_SOURCE_DIR}/${PROJECT_NAME}/${PROJECT_NAME}_export.h
  )

set_target_properties(${PROJECT_NAME} PROPERTIES
    LANGUAGES C
    CXX_STANDARD 11
    CXX_STANDARD_REQUIRED ON
    CXX_EXTENSIONS OFF
    VERSION ${KALIGN_LIBRARY_VERSION_STRING}
    SOVERSION ${KALIGN_LIBRARY_VERSION_MAJOR}
    PUBLIC_HEADER "${public_header_files}"
    CXX_VISIBILITY_PRESET hidden
    VISIBILITY_INLINES_HIDDEN 1
    )

target_sources(${PROJECT_NAME}
    PRIVATE
    ${public_header_files}
    $<TARGET_OBJECTS:${PROJECT_NAME}_OBJ>        
    )

# Define headers for this library. PUBLIC headers are used for
# compiling the library, and will be added to consumers' build
# paths.
target_include_directories(${PROJECT_NAME}
    PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
        $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
        $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>  
    )

target_include_directories(${PROJECT_NAME}
  PRIVATE
  src
  
  )

target_link_libraries(${PROJECT_NAME} PRIVATE m)

if(OpenMP_C_FOUND)
    target_link_libraries(${PROJECT_NAME} PRIVATE OpenMP::OpenMP_C)
endif()


add_library(${PROJECT_NAME}_static STATIC
  ${public_header_files}
    $<TARGET_OBJECTS:${PROJECT_NAME}_OBJ>        
    )
  
set_target_properties(${PROJECT_NAME}_static PROPERTIES
    LANGUAGES C
    CXX_STANDARD 11
    CXX_STANDARD_REQUIRED ON
    CXX_EXTENSIONS OFF
    VERSION ${KALIGN_LIBRARY_VERSION_STRING}
    SOVERSION ${KALIGN_LIBRARY_VERSION_MAJOR}
    PUBLIC_HEADER "${public_header_files}"
    CXX_VISIBILITY_PRESET hidden
    VISIBILITY_INLINES_HIDDEN 1
    )

target_include_directories(${PROJECT_NAME}_static
    PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
        $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
        $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>  
    )

target_include_directories(${PROJECT_NAME}_static
  PRIVATE
  src
  )

target_link_libraries(${PROJECT_NAME}_static PRIVATE m)

if(OpenMP_C_FOUND)
    target_link_libraries(${PROJECT_NAME}_static PRIVATE OpenMP::OpenMP_C)
endif()

add_library(tldevel STATIC
  src/tldevel.c
  src/tlmisc.c
  src/tlrng.c
  src/esl_stopwatch.c
  )

target_include_directories(tldevel 
  PUBLIC ${CMAKE_CURRENT_SOURCE_DIR}/src
  )
target_link_libraries(tldevel PRIVATE m)

# adjust this path depending where cmake searches for the target files
set(ConfigPackageLocation "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}")

# 'make install' to the correct locations (provided by GNUInstallDirs).
install(TARGETS ${PROJECT_NAME}
  EXPORT ${PROJECT_NAME}Targets
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT Library
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT Library
    
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT Library # This is for Windows
  PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${PROJECT_NAME} COMPONENT Development
  INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
  )

install(EXPORT ${PROJECT_NAME}Targets
  FILE
    ${PROJECT_NAME}Targets.cmake
  NAMESPACE
    ${NAMESPACE_NAME}::
  DESTINATION
    ${ConfigPackageLocation}
  COMPONENT
    Development
)

configure_package_config_file(
    ${PROJECT_NAME}Config.cmake.in
    ${PROJECT_NAME}Config.cmake
    INSTALL_DESTINATION "${ConfigPackageLocation}"
    PATH_VARS CMAKE_INSTALL_PREFIX
    )
  
write_basic_package_version_file(
    ${PROJECT_NAME}ConfigVersion.cmake
    VERSION ${KALIGN_LIBRARY_VERSION_STRING}
    COMPATIBILITY AnyNewerVersion
    )

install(
  FILES
    "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Config.cmake"
    "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake"
  DESTINATION
    ${ConfigPackageLocation}
  COMPONENT
    Development
)


add_executable(bpm_utest
  src/tldevel.c
  src/tlrng.c
  src/esl_stopwatch.c
  src/alphabet.c
  src/bpm.c
  src/bpm_test.c 
  
  
  )
target_link_libraries(bpm_utest PRIVATE m)

add_test(
  NAME bpm_utest
  COMMAND bpm_utest
  )

add_executable(alphabet_utest
  src/tldevel.c
  src/alphabet.c   
  )

set_target_properties(alphabet_utest PROPERTIES COMPILE_FLAGS "-DUTEST_ALPHABET")
add_test(
  NAME alphabet_utest
  COMMAND alphabet_utest
  )
   
add_executable(edist_utest
  src/tldevel.c
  src/tlrng.c
  src/esl_stopwatch.c
  src/euclidean_dist.c
  )


target_link_libraries(edist_utest PRIVATE m)
set_target_properties(edist_utest PROPERTIES COMPILE_FLAGS "-DUTEST_EDIST")
add_test(
  NAME edist_utest
  COMMAND edist_utest
  )


add_executable(task_utest
  src/tldevel.c
  src/tlrng.c
  src/task.c  
  )


target_link_libraries(task_utest PRIVATE m)
set_target_properties(task_utest PROPERTIES COMPILE_FLAGS "-DTASKWRITETEST")
add_test(
  NAME task_utest
  COMMAND task_utest
  )

=== src/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)

# Build library in sub-directories
if (NOT TARGET kalign::kalign)
  add_subdirectory(${PROJECT_SOURCE_DIR}/lib build EXCLUDE_FROM_ALL)
endif()

# link to installed library 
# if (NOT TARGET kalign::kalign)
#   find_package(kalign)
# endif()

if(NOT KALIGN_PACKAGE_NAME)
  set(KALIGN_PACKAGE_NAME ${CMAKE_PROJECT_NAME})
endif()

if(NOT KALIGN_PACKAGE_VERSION)
  set(KALIGN_PACKAGE_VERSION ${KALIGN_LIBRARY_VERSION_STRING})
endif()

configure_file ("${CMAKE_CURRENT_SOURCE_DIR}/version.h.in"
  "version.h" )


add_executable(kalign-bin  
  run_kalign.c
  parameters.c
  
  )
# Link with static library.... 
target_link_libraries(kalign-bin PRIVATE tldevel ${PROJECT_NAME}_static )

set_target_properties(kalign-bin
  PROPERTIES OUTPUT_NAME kalign)

add_executable(kalignfmt
  
  run_reformat.c
  parameters.c
  )

install(TARGETS kalign-bin DESTINATION bin)

target_link_libraries(kalignfmt PRIVATE tldevel kalign::kalign)

=== tests/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)

# Build library in sub-directories
if (NOT TARGET kalign::kalign)
  add_subdirectory(${PROJECT_SOURCE_DIR}/lib build EXCLUDE_FROM_ALL)
endif()

# link to installed library 
if (NOT TARGET kalign::kalign)
  find_package(kalign)
endif()

add_executable(largebench
  large_benchmark.c
  )
target_link_libraries(largebench tldevel   ${PROJECT_NAME}_static)

add_executable(kalign_io_test
  kalign_io_test.c
  )

target_link_libraries(kalign_io_test kalign::kalign)





add_executable(kalign_lib_test
  kalign_lib_test.c
  )
target_link_libraries(kalign_lib_test kalign::kalign)

add_executable(kalign_cmp_test
  kalign_cmp_test.c
  )
target_link_libraries(kalign_cmp_test kalign::kalign)

add_executable(kaligncpp
   kalign_lib_testCXX.cpp)
target_link_libraries(kaligncpp kalign::kalign)

add_test(
  NAME C++Lib
  COMMAND kaligncpp
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  )


#BB11001.tfa     
add_test(
  NAME kalign_itest_BB11001.tfa
  COMMAND kalign-bin ${CMAKE_CURRENT_SOURCE_DIR}/data/BB11001.tfa
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  )

#BB11001_EOF.msf
add_test(
  NAME kalign_itest_BB11001_EOF.msf
  COMMAND kalign-bin ${CMAKE_CURRENT_SOURCE_DIR}/data/BB11001_EOF.msf
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  )

#BB12006.msf
add_test(
  NAME kalign_itest_BB12006.msf
  COMMAND kalign-bin ${CMAKE_CURRENT_SOURCE_DIR}/data/BB12006.msf
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  )

#BB12006.tfa
add_test(
  NAME kalign_itest_BB12006.tfa
  COMMAND kalign-bin ${CMAKE_CURRENT_SOURCE_DIR}/data/BB12006.tfa
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  )

#BB30014.msf     
add_test(
  NAME kalign_itest_BB30014.msf
  COMMAND kalign-bin ${CMAKE_CURRENT_SOURCE_DIR}/data/BB12006.tfa
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  )

#BB30014.tfa
add_test(
  NAME kalign_itest_BB30014.tfa
  COMMAND kalign-bin ${CMAKE_CURRENT_SOURCE_DIR}/data/BB30014.tfa
  WORKING_DIRECTORY 
${CMAKE_CURRENT_SOURCE_DIR}
  )

=== debian/changelog ===
kalign (1:3.3.5-1) unstable; urgency=medium

  * New upstream version
  * Standards-Version: 4.6.2 (routine-update)

 -- Andreas Tille <tille@debian.org>  Mon, 06 Feb 2023 07:35:19 +0100

kalign (1:3.3.4-3) unstable; urgency=medium

  * Team Upload.
  * d/rules: Install from obj-$(DEB_HOST_GNU_TYPE) instead of
    DEB_HOST_MULTIARCH in order to fix build on i386

 -- Nilesh Patra <nilesh@debian.org>  Sun, 06 Nov 2022 11:40:17 +0530

kalign (1:3.3.4-2) unstable; urgency=medium

  * Team Upload.
  * install kalignfmt for other archs as well

 -- Nilesh Patra <nilesh@debian.org>  Sun, 06 Nov 2022 04:16:14 +0530

kalign (1:3.3.4-1) unstable; urgency=medium

  [ Andreas Tille ]
  * Team Upload.
  * Fix watch file
  * New upstream version
  * Standards-Version: 4.6.1 (routine-update)

  [ Nilesh Patra ]
  * d/control:
    + Add B-D on cmake
    + Remove B-D on libsimde-dev, also remove Built-Using field.
  * debian/patches:
    + Drop keep-debugging: debug flags are being passed now w/ cmake
    + Drop debian/patches/no-native-build: no native build anymore
    + Drop simde patch: no longer needed, upstream has added
      conditions for inclusions on higher SIMD levels
      of intel-specific header files
    + Add pass-proper-flags.patch: Set proper cflags/cxxflags for other simd
      levels than avx2, otherwise cflags are set to baseline for other supported
      simd levels.
  * d/rules:
    + Update rules layout from scratch as buildsystem changed
      from autotools -> cmake
    + Remove timescorealn as this is no longer provided/installed, change
      that with kalignfmt
    + Disable building shared lib, which is set to ON by default w/ this
      release.
      The SOLIBS should move into a new lib package anyway, and should not be
      here in the binary package
    + Install all relevant simd level binaries properly
    + Test binary for every simd level
    + Remove static lib and .cmake files which should not be present
      with this bin package
    + Install simd-dispatcher script for amd64
  * d/t/run-unit-test:
    + Kalign no longer allows un-aligned seq to be re-formatted,
      hence removing test 7
  * Manpage changes:
    + Add manpage for kalignfmt and update old manpage for kalign
    + Remove manpage for timescorealn
  * Update installing examples at right location
    + dev/ dir has been pruned, change that to tests/data
  * Add d/clean for cleaning obj-*
  * Update dispatcher script to supported simd levels
  * Remove copyright notices/mentions of autoconf stuff which has been removed
  * Remove author notice from manpage
  * Mention myself in the copyright
  * Disable reprotest in salsa CI

 -- Nilesh Patra <nilesh@debian.org>  Sat, 05 Nov 2022 22:20:20 +0000

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Build rules for the Debian package kalign

include /usr/share/dpkg/default.mk
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
OBJ_DIR=obj-$(DEB_HOST_GNU_TYPE)
prefix=$(CURDIR)/debian/$(DEB_SOURCE)/usr
libexecdir=$(prefix)/lib/$(DEB_SOURCE)

%:
	dh $@

AMD64_SIMD_LEVELS=avx2 avx sse4.1 ssse3 sse3
i386_SIMD_LEVELS=sse2 sse

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_SHARED_LIBS=OFF -DINSTALL_PREFIX=/usr -DENABLE_SSE=OFF -DENABLE_AVX=OFF -DENABLE_AVX2=OFF
ifeq (amd64,$(DEB_HOST_ARCH))
	dh_auto_configure --builddirectory obj-sse4.1 -- -DBUILD_SHARED_LIBS=OFF -DINSTALL_PREFIX=/usr -DENABLE_SSE=ON -DENABLE_AVX=OFF -DENABLE_AVX2=OFF
	dh_auto_configure --builddirectory obj-avx -- -DBUILD_SHARED_LIBS=OFF -DINSTALL_PREFIX=/usr -DENABLE_SSE=ON -DENABLE_AVX=ON -DENABLE_AVX2=OFF
	dh_auto_configure --builddirectory obj-avx2 -- -DBUILD_SHARED_LIBS=OFF -DINSTALL_PREFIX=/usr -DENABLE_SSE=ON -DENABLE_AVX=ON -DENABLE_AVX2=ON
endif

override_dh_auto_build:
	dh_auto_build
ifeq (amd64,$(DEB_HOST_ARCH))
	dh_auto_build --builddirectory obj-sse4.1
	dh_auto_build --builddirectory obj-avx
	dh_auto_build --builddirectory obj-avx2
endif

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	dh_auto_test
ifeq (amd64,$(DEB_HOST_ARCH))
	set -e ; for SIMD in avx2 avx sse4.1 ; do \
		if lscpu | grep -q $${SIMD} ; then \
			cd "obj-$${SIMD}/" && \
			ctest --verbose ; \
			cd .. ; \
		fi ; \
	done
endif
endif

override_dh_install:
	dh_install
	rm -rf debian/$(DEB_SOURCE)/usr/lib/$(DEB_HOST_MULTIARCH)/
	dh_install obj-$(DEB_HOST_GNU_TYPE)/src/kalignfmt usr/bin
ifeq (amd64,$(DEB_HOST_ARCH))
	mkdir -p debian/$(DEB_SOURCE)/usr/lib/$(DEB_SOURCE)/bin
	cp obj-avx2/src/kalign debian/$(DEB_SOURCE)/usr/lib/$(DEB_SOURCE)/kalign-avx2
	cp obj-avx/src/kalign debian/$(DEB_SOURCE)/usr/lib/$(DEB_SOURCE)/kalign-avx
	cp obj-sse4.1/src/kalign debian/$(DEB_SOURCE)/usr/lib/$(DEB_SOURCE)/kalign-sse4.1
	cp obj-avx2/src/kalignfmt debian/$(DEB_SOURCE)/usr/lib/$(DEB_SOURCE)/kalignfmt-avx2
	cp obj-avx/src/kalignfmt debian/$(DEB_SOURCE)/usr/lib/$(DEB_SOURCE)/kalignfmt-avx
	cp obj-sse4.1/src/kalignfmt debian/$(DEB_SOURCE)/usr/lib/$(DEB_SOURCE)/kalignfmt-sse4.1
	mv debian/$(DEB_SOURCE)/usr/bin/kalign debian/$(DEB_SOURCE)/usr/lib/$(DEB_SOURCE)/kalign-plain
	mv debian/$(DEB_SOURCE)/usr/bin/kalignfmt debian/$(DEB_SOURCE)/usr/lib/$(DEB_SOURCE)/kalignfmt-plain
	dh_install -pkalign debian/bin/simd-dispatch /usr/lib/$(DEB_SOURCE)/bin
	cd $(CURDIR)/debian/$(DEB_SOURCE)/usr/bin && \
		ln -s ../lib/$(DEB_SOURCE)/bin/simd-dispatch kalign
	cd $(CURDIR)/debian/$(DEB_SOURCE)/usr/bin && \
		ln -s ../lib/$(DEB_SOURCE)/bin/simd-dispatch kalignfmt
endif

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
  https://github.com/TimoLassmann/kalign/tags .*/v@ANY_VERSION@\.tar\.gz

## kalign 3.4.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.1)
+cmake_minimum_required(VERSION 3.18)
 
 project(kalign LANGUAGES C CXX)
 
@@ -12,8 +12,8 @@
 include(GenerateExportHeader)
 
 set(KALIGN_LIBRARY_VERSION_MAJOR 3)
-set(KALIGN_LIBRARY_VERSION_MINOR 3)
-set(KALIGN_LIBRARY_VERSION_PATCH 5)
+set(KALIGN_LIBRARY_VERSION_MINOR 4)
+set(KALIGN_LIBRARY_VERSION_PATCH 0)
 set(KALIGN_LIBRARY_VERSION_STRING ${KALIGN_LIBRARY_VERSION_MAJOR}.${KALIGN_LIBRARY_VERSION_MINOR}.${KALIGN_LIBRARY_VERSION_PATCH})
 
 
@@ -29,6 +29,12 @@
 
 add_compile_options("$<$<CONFIG:RELEASE>:-W;-Wall;-O3;-pedantic>")
 add_compile_options("$<$<CONFIG:DEBUG>:-W;-Wall;-O0;-g;-pedantic>")
+add_compile_options("$<$<CONFIG:ASAN>:-W;-Wall;-Wextra;-O0;-g;-DDEBUG;-pedantic;-ffunction-sections;-fdata-sections;-fstack-protector-strong;-fsanitize=address>")
+
+if(CMAKE_BUILD_TYPE MATCHES ASAN)
+  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fsanitize=address")
+  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -fsanitize=address")
+endif()
 
 if(CMAKE_PROJECT_NAME STREQUAL PROJECT_NAME)
   if (MSVC)
@@ -62,7 +68,7 @@
   if(OPENMP_FOUND OR OpenMP_FOUND)
     message(STATUS "OpenMP is enabled.")
      
-     add_definitions (-DHAVE_OPENMP)
+    add_definitions (-DHAVE_OPENMP)
   else(OPENMP_FOUND OR OpenMP_FOUND)
     message(STATUS "OpenMP not supported")
   endif(OPENMP_FOUND OR OpenMP_FOUND)
@@ -168,8 +174,6 @@
   set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DNOHAVE_AVX2")
 endif(HAVE_AVX2)
 
-
-
 add_subdirectory(lib)
 add_subdirectory(src)
 add_subdirectory(tests)

=== lib/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.1)
+cmake_minimum_required(VERSION 3.18)
 
 if(NOT KALIGN_PACKAGE_NAME)
   set(KALIGN_PACKAGE_NAME ${CMAKE_PROJECT_NAME})
@@ -26,6 +26,7 @@
   src/msa_misc.c
   src/msa_check.c
   src/msa_cmp.c
+  src/msa_sort.c
   src/alphabet.c
 
   src/task.c
@@ -47,6 +48,8 @@
   src/aln_seqprofile.c
   src/aln_profileprofile.c
   src/weave_alignment.c
+
+  # src/coretralign.c
   # src/test.h
   )
 
@@ -55,6 +58,7 @@
 if(OpenMP_C_FOUND)  
   target_link_libraries(${PROJECT_NAME}_OBJ PRIVATE OpenMP::OpenMP_C)
 endif(OpenMP_C_FOUND)
+
 
 target_include_directories(${PROJECT_NAME}_OBJ
   PRIVATE
@@ -78,32 +82,32 @@
   )
 
 set_target_properties(${PROJECT_NAME} PROPERTIES
-    LANGUAGES C
-    CXX_STANDARD 11
-    CXX_STANDARD_REQUIRED ON
-    CXX_EXTENSIONS OFF
-    VERSION ${KALIGN_LIBRARY_VERSION_STRING}
-    SOVERSION ${KALIGN_LIBRARY_VERSION_MAJOR}
-    PUBLIC_HEADER "${public_header_files}"
-    CXX_VISIBILITY_PRESET hidden
-    VISIBILITY_INLINES_HIDDEN 1
-    )
+  LANGUAGES C
+  CXX_STANDARD 11
+  CXX_STANDARD_REQUIRED ON
+  CXX_EXTENSIONS OFF
+  VERSION ${KALIGN_LIBRARY_VERSION_STRING}
+  SOVERSION ${KALIGN_LIBRARY_VERSION_MAJOR}
+  PUBLIC_HEADER "${public_header_files}"
+  CXX_VISIBILITY_PRESET hidden
+  VISIBILITY_INLINES_HIDDEN 1
+  )
 
 target_sources(${PROJECT_NAME}
-    PRIVATE
-    ${public_header_files}
-    $<TARGET_OBJECTS:${PROJECT_NAME}_OBJ>        
-    )
+  PRIVATE
+  ${public_header_files}
+  $<TARGET_OBJECTS:${PROJECT_NAME}_OBJ>        
+  )
 
 # Define headers for this library. PUBLIC headers are used for
 # compiling the library, and will be added to consumers' build
 # paths.
 target_include_directories(${PROJECT_NAME}
-    PUBLIC
-        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
-        $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
-        $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>  
-    )
+  PUBLIC
+  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
+  $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
+  $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>  
+  )
 
 target_include_directories(${PROJECT_NAME}
   PRIVATE
@@ -114,33 +118,34 @@
 target_link_libraries(${PROJECT_NAME} PRIVATE m)
 
 if(OpenMP_C_FOUND)
-    target_link_libraries(${PROJECT_NAME} PRIVATE OpenMP::OpenMP_C)
-endif()
+  target_link_libraries(${PROJECT_NAME} PRIVATE OpenMP::OpenMP_C)
+endif()
+
 
 
 add_library(${PROJECT_NAME}_static STATIC
   ${public_header_files}
-    $<TARGET_OBJECTS:${PROJECT_NAME}_OBJ>        
-    )
-  
+  $<TARGET_OBJECTS:${PROJECT_NAME}_OBJ>        
+  )
+
 set_target_properties(${PROJECT_NAME}_static PROPERTIES
-    LANGUAGES C
-    CXX_STANDARD 11
-    CXX_STANDARD_REQUIRED ON
-    CXX_EXTENSIONS OFF
-    VERSION ${KALIGN_LIBRARY_VERSION_STRING}
-    SOVERSION ${KALIGN_LIBRARY_VERSION_MAJOR}
-    PUBLIC_HEADER "${public_header_files}"
-    CXX_VISIBILITY_PRESET hidden
-    VISIBILITY_INLINES_HIDDEN 1
-    )
+  LANGUAGES C
+  CXX_STANDARD 11
+  CXX_STANDARD_REQUIRED ON
+  CXX_EXTENSIONS OFF
+  VERSION ${KALIGN_LIBRARY_VERSION_STRING}
+  SOVERSION ${KALIGN_LIBRARY_VERSION_MAJOR}
+  PUBLIC_HEADER "${public_header_files}"
+  CXX_VISIBILITY_PRESET hidden
+  VISIBILITY_INLINES_HIDDEN 1
+  )
 
 target_include_directories(${PROJECT_NAME}_static
-    PUBLIC
-        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
-        $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
-        $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>  
-    )
+  PUBLIC
+  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
+  $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
+  $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>  
+  )
 
 target_include_directories(${PROJECT_NAME}_static
   PRIVATE
@@ -150,8 +155,9 @@
 target_link_libraries(${PROJECT_NAME}_static PRIVATE m)
 
 if(OpenMP_C_FOUND)
-    target_link_libraries(${PROJECT_NAME}_static PRIVATE OpenMP::OpenMP_C)
-endif()
+  target_link_libraries(${PROJECT_NAME}_static PRIVATE OpenMP::OpenMP_C)
+endif()
+
 
 add_library(tldevel STATIC
   src/tldevel.c

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.1)
+cmake_minimum_required(VERSION 3.18)
 
 # Build library in sub-directories
 if (NOT TARGET kalign::kalign)
@@ -33,6 +33,8 @@
 set_target_properties(kalign-bin
   PROPERTIES OUTPUT_NAME kalign)
 
+
+
 add_executable(kalignfmt
   
   run_reformat.c

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.1)
+cmake_minimum_required(VERSION 3.18)
 
 # Build library in sub-directories
 if (NOT TARGET kalign::kalign)
@@ -21,6 +21,12 @@
 
 target_link_libraries(kalign_io_test kalign::kalign)
 
+
+add_executable(dssim
+  dssim_test.c
+  dssim.c
+  )
+target_link_libraries(dssim tldevel kalign::kalign)
 
 
 
@@ -89,3 +95,9 @@
 ${CMAKE_CURRENT_SOURCE_DIR}
   )
 
+
+add_test(
+  NAME DSSIM_takes_a_min
+  COMMAND dssim
+  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
+  )

=== debian/changelog ===
kalign (1:3.4.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * d/patches: disable pass-proper-flags.patch for now.

 -- Michael R. Crusoe <crusoe@debian.org>  Tue, 02 Apr 2024 13:49:50 +0200

kalign (1:3.3.5-2) unstable; urgency=medium

  * Team upload.
  * d/rules: pass the openmp-simd compiler flags.
  * d/rules: set the "simde:Built-Using" substitution variable used in
    d/control.

 -- Michael R. Crusoe <crusoe@debian.org>  Mon, 25 Mar 2024 09:13:42 +0100

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,8 @@
 Uploaders: Charles Plessy <plessy@debian.org>, Andreas Tille <tille@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper-compat (= 13), libsimde-dev
-Standards-Version: 4.6.0
+Build-Depends: debhelper-compat (= 13), libsimde-dev, cmake
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/med-team/kalign
 Vcs-Git: https://salsa.debian.org/med-team/kalign.git
 Homepage: https://msa.sbc.su.se/

=== debian/rules ===
--- 
+++ 
@@ -4,6 +4,8 @@
 
 include /usr/share/dpkg/default.mk
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+export DEB_CFLAGS_MAINT_APPEND+=-DSIMDE_ENABLE_OPENMP -fopenmp-simd -O3
+export DEB_CXXFLAGS_MAINT_APPEND+=-DSIMDE_ENABLE_OPENMP -fopenmp-simd -O3
 OBJ_DIR=obj-$(DEB_HOST_GNU_TYPE)
 prefix=$(CURDIR)/debian/$(DEB_SOURCE)/usr
 libexecdir=$(prefix)/lib/$(DEB_SOURCE)
@@ -22,17 +24,15 @@
 	dh_auto_configure --builddirectory obj-avx2 -- -DBUILD_SHARED_LIBS=OFF -DINSTALL_PREFIX=/usr -DENABLE_SSE=ON -DENABLE_AVX=ON -DENABLE_AVX2=ON
 endif
 
-override_dh_auto_build:
-	dh_auto_build
 ifeq (amd64,$(DEB_HOST_ARCH))
+execute_after_dh_auto_build:
 	dh_auto_build --builddirectory obj-sse4.1
 	dh_auto_build --builddirectory obj-avx
 	dh_auto_build --builddirectory obj-avx2
 endif
 
-override_dh_auto_test:
+execute_after_dh_auto_test:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
-	dh_auto_test
 ifeq (amd64,$(DEB_HOST_ARCH))
 	set -e ; for SIMD in avx2 avx sse4.1 ; do \
 		if lscpu | grep -q $${SIMD} ; then \
@@ -44,8 +44,7 @@
 endif
 endif
 
-override_dh_install:
-	dh_install
+execute_after_dh_install:
 	rm -rf debian/$(DEB_SOURCE)/usr/lib/$(DEB_HOST_MULTIARCH)/
 	dh_install obj-$(DEB_HOST_GNU_TYPE)/src/kalignfmt usr/bin
 ifeq (amd64,$(DEB_HOST_ARCH))
@@ -64,3 +63,6 @@
 	cd $(CURDIR)/debian/$(DEB_SOURCE)/usr/bin && \
 		ln -s ../lib/$(DEB_SOURCE)/bin/simd-dispatch kalignfmt
 endif
+
+override_dh_gencontrol:
+	dh_gencontrol -- -Vsimde:Built-Using="$(shell dpkg-query -f '$${source:Package} (= $${source:Version}), ' -W "libsimde-dev")"
